CREATE OR REPLACE PROCEDURE IMPORTA_COMPRA_AVIVA
IS
   V_DTENTRADA       DATE;
   V_CDPRODEXTERNO   VARCHAR2(20);
   V_VRQUANTIDADE    FLOAT;
   V_VRUNITARIO      FLOAT;
   V_IDINTERFACE     VARCHAR2(1);
   
   V_NRSEQITPROD  INTEGER;
   V_CDFILIAL     VARCHAR2(4);
   V_ERRO         VARCHAR2(500);
   V_CDPRODUTO    VARCHAR2(10);
   V_CDPRODESTO   VARCHAR2(10);
   V_CDARVPROD    VARCHAR2(20);
   V_NMPRODUTO    VARCHAR2(50);
   V_VRFATOCONV   FLOAT;
   
   V_CDALMOXARIFE VARCHAR2(6);
   V_CDLOCALESTOQ VARCHAR2(6);
   V_NRLOTEESTQ   VARCHAR2(20);
   V_NRSUBLOTE    VARCHAR2(4);
   V_VRESTOQDIA   FLOAT;
   V_QTESTCONV    FLOAT;
   V_VRLANCTOBRUT FLOAT;
   
   V_ALMOXARIFE   VARCHAR2(6);
   V_LOCALESTOQ   VARCHAR2(6);
   V_IDUTILLOTE   VARCHAR2(1);
   
   V_DATAPROC     DATE;
   V_DTINICIAL    DATE;
   V_DTFINAL      DATE;
   
   V_NRLANCESTQ   VARCHAR2(20);
   V_CDOPERADOR   VARCHAR2(12);
   
   V_VALIDA       VARCHAR2(10);
   
   CURSOR C_COMPRA IS
      SELECT DTENTRADA, CDPRODEXTERNO, VRQUANTIDADE, VRUNITARIO, IDINTERFACE
        FROM INT_COMPRA_AVIVA
       WHERE DTIMPORTACAO IS NULL
         AND LOG_ERRO IS NULL
       ORDER BY DTENTRADA;
BEGIN
   V_CDFILIAL := '9999';
   V_CDOPERADOR := '999999999999';
   V_VALIDA := ' ';
   BEGIN
      SELECT DTPROCESSA
        INTO V_DATAPROC
        FROM PARAMFILIAL
       WHERE CDFILIAL = V_CDFILIAL;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_DATAPROC := SYSDATE;
   END;
   
   BEGIN
      SELECT NVL(CDALMOXARIFE, ' '), NVL(CDLOCALESTOQ, ' '), IDUTILLOTE
        INTO V_ALMOXARIFE, V_LOCALESTOQ, V_IDUTILLOTE
        FROM PARAMFILIAL
       WHERE CDFILIAL = V_CDFILIAL;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_ALMOXARIFE := ' ';
         V_IDUTILLOTE := 'N';
   END;
   
   OPEN C_COMPRA;
   LOOP
      FETCH C_COMPRA INTO V_DTENTRADA, V_CDPRODEXTERNO, V_VRQUANTIDADE, V_VRUNITARIO, V_IDINTERFACE;
      EXIT WHEN C_COMPRA%NOTFOUND;
      
      BEGIN
         SELECT CDPRODUTO, CDARVPROD, NMPRODUTO, CDPRODESTO, NVL(VRFATOCONV,1)
           INTO V_CDPRODUTO, V_CDARVPROD, V_NMPRODUTO, V_CDPRODESTO, V_VRFATOCONV
           FROM PRODUTO
          WHERE CDPRODINTE = V_CDPRODEXTERNO;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            ROLLBACK;
            V_ERRO := 'Produto n'||CHR(227)||'o cadastrado';
            EXIT;
         WHEN DUP_VAL_ON_INDEX THEN
            ROLLBACK;
            V_ERRO := 'Mais de um produto com o c'||CHR(243)||'digo '||V_CDPRODEXTERNO||' cadastrado.';
            EXIT;
      END;
      
      IF (V_ERRO IS NULL) THEN
         IF (V_NRLANCESTQ IS NOT NULL) AND (TO_CHAR(V_DTENTRADA, 'YYYYMMDD') <> V_VALIDA) THEN
            /*Atualizao de estoque de produtos*/
            IF V_DTENTRADA < V_DATAPROC THEN
               V_DTINICIAL := V_DTENTRADA;
            ELSE
               V_DTINICIAL := V_DATAPROC;
            END IF;
            
            IF V_DTENTRADA > V_DATAPROC THEN
               V_DTFINAL := V_DTENTRADA;
            ELSE
               V_DTFINAL := V_DATAPROC;
            END IF;
            
            ATUALIZA_ESTOQUE(V_CDFILIAL, V_DTINICIAL, V_DTFINAL, V_CDFILIAL, V_NRLANCESTQ);
         END IF;
         
         IF (TO_CHAR(V_DTENTRADA, 'YYYYMMDD') <> V_VALIDA) THEN
            V_VALIDA := TO_CHAR(V_DTENTRADA, 'YYYYMMDD');
            V_NRSEQITPROD := 1;
            
            NOVO_CODIGO('LANCTOEST'||V_CDFILIAL, V_NRLANCESTQ);
            V_NRLANCESTQ := SUBSTR(V_NRLANCESTQ, -10);
            
            INSERT INTO LANCTOESTOQ(CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ, DSLANCESTQ, IDALTCUSMED,
                                    CDFILIMOVI, CDOPERADOR)
            VALUES(V_CDFILIAL, V_NRLANCESTQ, '2', TRUNC(V_DTENTRADA), 'Entrada de estoque via integrao sistema AVIVA', 'S',
                   V_CDFILIAL, V_CDOPERADOR);
         END IF;
         
         BEGIN
            SELECT NVL(MAX(CDALMOXARIFE), V_ALMOXARIFE), NVL(MAX(CDLOCALESTOQ), V_LOCALESTOQ), NVL(MAX(NRLOTEESTQ), ' '), NVL(MAX(NRSUBLOTE), ' ')
              INTO V_CDALMOXARIFE, V_CDLOCALESTOQ, V_NRLOTEESTQ, V_NRSUBLOTE
              FROM POSESTDIA P
             WHERE P.CDFILIAL = V_CDFILIAL
               AND P.CDPRODUTO = V_CDPRODESTO
               AND P.QTESTOQDIA <> 0
               AND P.DTPOSIESTQ = (SELECT MAX(DTPOSIESTQ)
                                     FROM POSESTDIA
                                    WHERE CDFILIAL = P.CDFILIAL
                                      AND CDALMOXARIFE = P.CDALMOXARIFE
                                      AND CDLOCALESTOQ = P.CDLOCALESTOQ
                                      AND NRLOTEESTQ = P.NRLOTEESTQ
                                      AND NRSUBLOTE = P.NRSUBLOTE
                                      AND CDPRODUTO = P.CDPRODUTO
                                      AND DTPOSIESTQ <= TO_DATE(V_DTENTRADA));
            
            IF ((TRIM(V_CDALMOXARIFE) IS NULL) AND (TRIM(V_ALMOXARIFE) IS NOT NULL)) THEN
               V_CDALMOXARIFE := V_ALMOXARIFE;
            END IF;
            
            IF ((TRIM(V_CDLOCALESTOQ) IS NULL) AND (TRIM(V_LOCALESTOQ) IS NOT NULL)) THEN
               V_CDLOCALESTOQ := V_LOCALESTOQ;
            END IF;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDALMOXARIFE := V_ALMOXARIFE; 
               V_CDLOCALESTOQ := V_LOCALESTOQ; 
               V_NRLOTEESTQ := ' '; 
               V_NRSUBLOTE := ' ';
         END;
         
         IF (V_IDUTILLOTE = 'S') THEN
            IF V_NRLOTEESTQ = ' ' THEN
               PRXLOTEPRODEST(V_CDFILIAL, V_DTENTRADA, V_CDPRODUTO, V_NRLOTEESTQ);               
            END IF;
         END IF;
         
         V_VRESTOQDIA   := (V_VRQUANTIDADE * V_VRUNITARIO);
         V_QTESTCONV    := (V_VRQUANTIDADE * V_VRFATOCONV);
         V_VRLANCTOBRUT := (V_VRESTOQDIA / V_QTESTCONV);
         
         INSERT INTO ITLANCTOEST(CDFILIAL, NRLANCESTQ, NRSEQUITEM, IDTIPOMOVI, CDPRODUTO, QTTOTLANCTO,  VRUNILANCTO, VRTOTLANCTO,
                                 DTLANCMOVI, IDORDEMCLC, CDPRODMOVI, QTLANCTOEST, VRLANCTOBRUT, VRLANCTOEST, CDFILIMOVI, CDALMOXARIFE,
                                 CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE)
         VALUES(V_CDFILIAL, V_NRLANCESTQ, LPAD(TO_CHAR(V_NRSEQITPROD), 4, '0'), '2', V_CDPRODUTO, V_VRQUANTIDADE, V_VRUNITARIO, V_VRESTOQDIA,
                TRUNC(V_DTENTRADA), '2', V_CDPRODESTO, V_QTESTCONV, V_VRLANCTOBRUT, V_VRLANCTOBRUT, V_CDFILIAL, V_CDALMOXARIFE,
                V_CDLOCALESTOQ, V_NRLOTEESTQ, V_NRSUBLOTE);
         
         V_NRSEQITPROD := V_NRSEQITPROD + 1;
         
         UPDATE INT_COMPRA_AVIVA
            SET DTIMPORTACAO  = SYSDATE,
                HRIMPORTACAO  = TO_CHAR(SYSDATE, 'HH24:MI')
          WHERE CDPRODEXTERNO = V_CDPRODEXTERNO
            AND DTENTRADA     = V_DTENTRADA;
      ELSE
         UPDATE INT_COMPRA_AVIVA
            SET LOG_ERRO = V_ERRO
          WHERE CDPRODEXTERNO = V_CDPRODEXTERNO
            AND DTENTRADA     = V_DTENTRADA;
      END IF;
   END LOOP;
   CLOSE C_COMPRA;
   
   IF V_DTENTRADA < V_DATAPROC THEN
      V_DTINICIAL := V_DTENTRADA;
   ELSE
      V_DTINICIAL := V_DATAPROC;
   END IF;
   
   IF V_DTENTRADA > V_DATAPROC THEN
      V_DTFINAL := V_DTENTRADA;
   ELSE
      V_DTFINAL := V_DATAPROC;
   END IF;
   
   ATUALIZA_ESTOQUE(V_CDFILIAL, V_DTINICIAL, V_DTFINAL, V_CDFILIAL, V_NRLANCESTQ);
   
   COMMIT;
EXCEPTION
   WHEN OTHERS THEN
      ROLLBACK;
      V_ERRO := SQLERRM(SQLCODE);
      
      UPDATE INT_COMPRA_AVIVA
         SET LOG_ERRO = V_ERRO
       WHERE CDPRODEXTERNO = V_CDPRODEXTERNO
         AND DTENTRADA     = V_DTENTRADA;
      
      COMMIT;
      IF C_COMPRA%ISOPEN THEN
         CLOSE C_COMPRA;
      END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('IMPORTA_COMPRA_AVIVA','6.35.020'); END;
/
