function Ped01100_dadosPedido(General, templateManager, ScreenService, MessageService, Ped01100_dadosPedido_Service, PedGeral_Utility) {
    
    this.quantItemLista = 0;

    this.setValues = function(){
        var widget = templateManager.container.getWidget('widgetDados');
        widget.applyDefaultValue();
        widget.getField('PRIORIDADE').setValue(["3", "2", "1"]);
        widget.getField('SITUACAOPEDIDO').setValue(["6", "5", "4", "3", "2", "1"]);
        widget.getField('SITUACAOITEM').setValue(["7", "6", "5", "4", "3", "2", "1"]);
        
        this.startFilterFilial();

         // this.filtroFilial();
        this.filtroNmPedido();
        this.filtroTpOper();
        this.filtroCliente();
        this.filtroProdutos();
        this.filtroVendedor();
        this.filtroVendedorComis();
        
        widget.reload();
    };

    this.startFilterFilial = function() {

        var widgetDados = this.getWidgetDados();

        widgetDados.getField('FILTRARFILIAL').setValue('L');

        this.filtroFilial();

        var fieldFilial = widgetDados.getField('NMFILIAL');
        var fieldCdFilial = widgetDados.getField('CDFILIAL');

        PedGeral_Utility.getFilialLogada().then(function(success) {
            
            var filial = [success.dataset.filial[0].NMFILIAL];
            var cdfilial = [success.dataset.filial[0].CDFILIAL];

            fieldFilial.setValue(filial);
            fieldCdFilial.setValue(cdfilial);
        
            templateManager.updateTemplate();

        }.bind(this));

    }; 
    
    this.filtroNmPedido = function(){
        var widget = templateManager.container.getWidget('widgetDados');
        if(widget.getField('FILTRAR').value() == 'L'){
           widget.getField('NMFANTCLIE').readOnly = false;
           widget.getField('INICIO').readOnly = true;
           widget.getField('FIM').readOnly = true;
           widget.getField('NMFANTCLIE').validations = {required: true};
           delete(widget.getField('INICIO').validations);
           delete(widget.getField('FIM').validations);
           widget.getField('INICIO').setValue('');
           widget.getField('FIM').setValue('');
        }else if(widget.getField('FILTRAR').value() == 'I'){
           widget.getField('NMFANTCLIE').readOnly = true;
           widget.getField('INICIO').readOnly = false;
           widget.getField('FIM').readOnly = false;
           widget.getField('INICIO').validations = {required: true};
           widget.getField('FIM').validations = {required: true};
           delete(widget.getField('NMFANTCLIE').validations);
           widget.getField('NMFANTCLIE').setValue('');
        }else if(widget.getField('FILTRAR').value() == 'T'){
           widget.getField('NMFANTCLIE').readOnly = true;
           widget.getField('INICIO').readOnly = true;
           widget.getField('FIM').readOnly = true;
           delete(widget.getField('INICIO').validations);
           delete(widget.getField('FIM').validations);
           delete(widget.getField('NMFANTCLIE').validations);
           widget.getField('NMFANTCLIE').setValue('');
           widget.getField('FIM').setValue('');
           widget.getField('INICIO').setValue('');
        }
        templateManager.updateTemplate();
    };

    this.checkQuantItemList = function() {

        var wid = templateManager.container.getActiveWidget();

        this.quantItemLista = wid.dataSource.data.length;

    };

    this.getTabbedWidgetDados = function() {

        return templateManager.container.getWidget('tabbedDadosPedido');

    };

    this.getWidgetDados = function() {

        return templateManager.container.getWidget('widgetDados');

    };
    
    this.filtraParametro = function(nomeFiltro, nomeLista) {
        var widget = this.getWidgetDados();

        var filtro = widget.getField(nomeFiltro);

        var fieldList = widget.getField(nomeLista);

        if(filtro.value() == 'L') {

            fieldList.readOnly = false;
            fieldList.validations = {required: true};

        } else {

            fieldList.readOnly = true;
            delete (fieldList.validations);
            fieldList.setValue('');

        }

        templateManager.updateTemplate();

    };

    this.filtroFilial = function(){
        
        this.filtraParametro('FILTRARFILIAL', 'NMFILIAL');

    };
    
    this.filtroTpOper = function(){
        
        this.filtraParametro('FILTRARTIPOOPERACAO', 'NMTIPOOPER');
    
    };
    
    this.filtroCliente = function(){
        
        this.filtraParametro('FILTRARCLIENTE', 'NMFANTCLIE2');

    };
    
    this.filtroProdutos = function(){
        
        this.filtraParametro('FILTRARPRODUTOS', 'NMPRODUTO');
        
    };
    
    this.filtroVendedor = function(){
        
        this.filtraParametro('FILTRARVENDEDOR', 'NMFANVEN');

    };
    
    this.filtroVendedorComis = function(){
        
        this.filtraParametro('FILTRARVENDEDORCOMIS', 'NMFANVEN2');

    };
    
    this.mudaLabel = function(){
        var tabbedWidget = templateManager.container.getWidget('tabbedDadosPedido');
        var widget = tabbedWidget.widgets[0];
        if(tabbedWidget.getField('RELATORIO').value() == 'PED01100'){
          widget.label = "Espelho do Pedido";
          delete(templateManager.container.getWidget('widgetDados').getField('DTPEDIDO').validations);
        }else if(tabbedWidget.getField('RELATORIO').value() == 'PED01101'){
          widget.label = "Dados do Pedido";
          delete(templateManager.container.getWidget('widgetDados').getField('DTPEDIDO').validations);
        }else if(tabbedWidget.getField('RELATORIO').value() == 'PED01103'){
          widget.label = "Pedido por Vendedor";
        }else if(tabbedWidget.getField('RELATORIO').value() == 'PED01104'){
          widget.label = "Preço de Venda x Preço de Custo (Analítico)";
        }else if(tabbedWidget.getField('RELATORIO').value() == 'PED01105'){
          widget.label = "Preço de Venda x Preço de Custo (Sintético)";
        }
    };
    
    this.concatParametro = function(fieldFiltro, fieldTodos, fieldLista, fieldValue) {

        var currentRowToSend = this.getTabbedWidgetDados().currentRow;

        var currentRowToRead = this.getWidgetDados().currentRow;

        if(currentRowToRead[fieldFiltro] == 'T'){
            
            currentRowToSend[fieldTodos] =  'T';
            currentRowToSend[fieldLista] =  '';

        }else if(currentRowToRead[fieldFiltro] == 'L'){
            
            currentRowToSend[fieldTodos] =  '';
            var array = currentRowToRead[fieldValue];
            var aux = '';
            
            for(var i=0; i < array.length; i++){
                aux += array[i] + '_';
            }
            
            currentRowToSend = this.validaConcat(currentRowToSend, fieldLista, fieldValue, aux);
        }

        return currentRowToSend;

    };

    this.validaConcat = function(currentRow, fieldLista, fieldValue, aux) {

        if(aux.length < 4000) {

            currentRow[fieldLista] = aux;

            return currentRow;

        } else {

            var widgetDados = this.getWidgetDados();

            var field = widgetDados.getField(fieldValue);

            var nomFieldGroup = null;

            var fieldGroups = widgetDados.fieldGroups;

            for(i = 0; i < fieldGroups.length; i++) {

                if(fieldGroups[i].name == field.fieldGroup) {

                    nomFieldGroup = fieldGroups[i].label;

                    break;

                }

            }

            param = { parametro: nomFieldGroup};
            
            MessageService.showMessageByCode('NUM_I_LIMIT',param);

            throw new Error('NUM_I_LIMIT');

        }

    };

    this.analizaQuantSeleciona = function(field, nomeFieldTodos) {

        if(field.value().length == this.quantItemLista) {

            var fieldTodos = field.widget.getField(nomeFieldTodos);

            fieldTodos.setValue('T');

            field.clearValue();

            field.readOnly = true;

            delete (field.validations);

            templateManager.updateTemplate();

        }

    };

    this.sitConcat = function(situacao,status,statusTodos) {

        var currentRowToRead = this.getWidgetDados().currentRow;
        var currentRowToSend = this.getTabbedWidgetDados().currentRow;

        var array = currentRowToRead[situacao];
        var aux = '';
        
        for(var i=0; i < array.length; i++){
            aux += array[i] + '_';
        }

        currentRowToSend[status] =  aux;
        currentRowToSend[statusTodos] = '';

        return currentRowToSend;

    };

    this.setCurrentRow = function(){
        var widget = templateManager.container.getWidget('tabbedDadosPedido');
        var currentWidget = templateManager.container.getWidget('tabbedDadosPedido').widgets[0].currentRow;    
        
        widget.currentRow.__report_name = widget.currentRow.RELATORIO;
        
        if(currentWidget.FILTRAR == 'T'){
            widget.currentRow.NRPEDIDOTODOS =  'T';
            widget.currentRow.NRPEDIDOLISTA =  '';
            widget.currentRow.NRPEDIDODE =  '';
            widget.currentRow.NRPEDIDOATE =  '';
        }else if(currentWidget.FILTRAR == 'L'){
            widget.currentRow.NRPEDIDOTODOS =  '';
            var listaNrpedido = currentWidget.NRPEDIDO;
            var lista = '';
            for(var i=0; i < listaNrpedido.length; i++){
                lista = lista + listaNrpedido[i] + '_';
            }

            this.validaConcat(widget.currentRow, 'NRPEDIDOLISTA','NRPEDIDO',lista);
            
            widget.currentRow.NRPEDIDODE =  '';
            widget.currentRow.NRPEDIDOATE =  '';
        }else if(currentWidget.FILTRAR == 'I'){
            widget.currentRow.NRPEDIDOTODOS =  '';
            widget.currentRow.NRPEDIDOLISTA = '';
            widget.currentRow.NRPEDIDODE =  currentWidget.INICIO;
            widget.currentRow.NRPEDIDOATE =  currentWidget.FIM;
        }
        
        widget.currentRow = this.concatParametro('FILTRARFILIAL','TCDFILIAL','LCDFILIAL','CDFILIAL');
        
        // if(currentWidget.FILTRARFILIAL == 'T'){
        //     widget.currentRow.TCDFILIAL =  'T';
        //     widget.currentRow.LCDFILIAL =  '';
        // }else if(currentWidget.FILTRARFILIAL == 'L'){
        //     widget.currentRow.TCDFILIAL =  '';
        //     var array = currentWidget.CDFILIAL;
        //     var aux = '';
        //     for(var j=0; j < array.length; j++){
        //         aux = aux + array[j] + '_';
        //     }
        //     widget.currentRow.LCDFILIAL = aux;
        // }
        
        widget.currentRow = this.concatParametro('FILTRARTIPOOPERACAO','TCDTIPOOPER','CDTIPOOPER','CDTIPOOPER');

        // if(currentWidget.FILTRARTIPOOPERACAO == 'T'){
        //     widget.currentRow.TCDTIPOOPER =  'T';
        //     widget.currentRow.CDTIPOOPER =  '';
        // }else if(currentWidget.FILTRARTIPOOPERACAO == 'L'){
        //     widget.currentRow.TCDTIPOOPER =  '';
        //     var array2 = currentWidget.CDTIPOOPER;
        //     var aux2 = '';
        //     for(var k=0; k < array2.length; k++){
        //         aux2 = aux2 + array2[k] + '_';
        //     }
            
        //     widget.currentRow.CDTIPOOPER = aux2;
        // }
        
        widget.currentRow = this.concatParametro('FILTRARCLIENTE','CLIENTETODOS','CLIENTELISTA','NRINSJURCLIE2');

        // if(currentWidget.FILTRARCLIENTE == 'T'){
        //     widget.currentRow.CLIENTETODOS =  'T';
        //     widget.currentRow.CLIENTELISTA =  '';
        // }else if(currentWidget.FILTRARCLIENTE == 'L'){
        //     widget.currentRow.CLIENTETODOS =  '';
        //     var array3 = currentWidget.NRINSJURCLIE2;
        //     var aux3 = '';
        //     for(var l=0; l < array3.length; l++){
        //         aux3 = aux3 + array3[l] + '_';
        //     }
        //     widget.currentRow.CLIENTELISTA = aux3;
        // }
        
        widget.currentRow = this.concatParametro('FILTRARPRODUTOS','PRODUTOTODOS','PRODUTOLISTA','CDARVPROD');
        
        // if(currentWidget.FILTRARPRODUTOS == 'T'){
        //     widget.currentRow.PRODUTOTODOS =  'T';
        //     widget.currentRow.PRODUTOLISTA =  '';
        // }else if(currentWidget.FILTRARPRODUTOS == 'L'){
        //     widget.currentRow.PRODUTOTODOS =  '';
        //     var array4 = currentWidget.CDARVPROD;
        //     var aux4 = '';
        //     for(var m=0; m < array4.length; m++){
        //         aux4 = aux4 + array4[m] + '_';
        //     }
        //     widget.currentRow.PRODUTOLISTA = aux4;
        // }
        
        widget.currentRow = this.concatParametro('FILTRARVENDEDOR','VENDEDORTODOS','VENDEDORLISTA','CDVENDEDOR');

        // if(currentWidget.FILTRARVENDEDOR == 'T'){
        //     widget.currentRow.VENDEDORTODOS =  'T';
        //     widget.currentRow.VENDEDORLISTA =  '';
        // }else if(currentWidget.FILTRARVENDEDOR == 'L'){
        //     widget.currentRow.VENDEDORTODOS =  '';
        //     var array5 = currentWidget.CDVENDEDOR;
        //     var aux5 = '';
        //     for(var n=0; n < array5.length; n++){
        //         aux5 = aux5 + array5[n] + '_';
        //     }
        //     widget.currentRow.VENDEDORLISTA = aux5;
        // }
        
        widget.currentRow = this.concatParametro('FILTRARVENDEDORCOMIS','VENDCOMISTODOS','VENDCOMISLISTA','CDVENDEDOR2');
        
        // if(currentWidget.FILTRARVENDEDORCOMIS == 'T'){
        //     widget.currentRow.VENDCOMISTODOS =  'T';
        //     widget.currentRow.VENDCOMISLISTA =  '';
        // }else if(currentWidget.FILTRARVENDEDORCOMIS == 'L'){
        //     widget.currentRow.VENDCOMISTODOS =  '';
        //     var array6 = currentWidget.CDVENDEDOR2;
        //     var aux6 = '';
        //     for(var o=0; o < array6.length; o++){
        //         aux6 = aux6 + array6[o] + '_';
        //     }
        //     widget.currentRow.VENDCOMISLISTA = aux6;
        // }
        
        widget.currentRow = this.sitConcat('SITUACAOPEDIDO','STATUS','STATUSTODOS');

        // var array7 = currentWidget.SITUACAOPEDIDO;
        // var aux7 = '';
        // for(var p=0; p < array7.length; p++){
        //     aux7 = aux7 + array7[p] + '_';
        // }
        // widget.currentRow.STATUS =  aux7;
        // widget.currentRow.STATUSTODOS = '';
        
        widget.currentRow = this.sitConcat('SITUACAOITEM','STATUSITEM','STATUSITEMTODOS');
        
        // var array8 = currentWidget.SITUACAOITEM;
        // var aux8 = '';
        // for(var q=0; q < array8.length; q++){
        //     aux8 = aux8 + array8[q] + '_';
        // }
        // widget.currentRow.STATUSITEM = aux8;
        // widget.currentRow.STATUSITEMTODOS = ''; 
        
        widget.currentRow = this.sitConcat('SITUACAOITEM','TIPOPEDIDO','TODOSPEDIDOS');

        // var array9 = currentWidget.SITUACAOITEM;
        // var aux9 = '';
        // for(var r=0; r < array9.length; r++){
        //     aux9 = aux9 + array9[r] + '_';
        // }
        // widget.currentRow.TIPOPEDIDO = aux9;
        // widget.currentRow.TODOSPEDIDOS = ''; 
        
        if(currentWidget.NRORDEMCMPPED != ''){
            widget.currentRow.NRORDEMCMPPED = currentWidget.NRORDEMCMPPED;
        }else{
            widget.currentRow.NRORDEMCMPPED = '';
        }
        
        if((currentWidget.DTPEDIDO.start != '') && (currentWidget.DTPEDIDO.end != '')){
            widget.currentRow.EMISSAODE = currentWidget.DTPEDIDO.start;
            widget.currentRow.EMISSAOATE = currentWidget.DTPEDIDO.end;
            widget.currentRow.EMISSAOTODOS = '';
        }else{
            widget.currentRow.EMISSAODE = '';
            widget.currentRow.EMISSAOATE = '';
            widget.currentRow.EMISSAOTODOS = 'T';
        }
        
        if((currentWidget.DTENTPED.start != '') && (currentWidget.DTENTPED.end != '')){
            widget.currentRow.ENTREGADE = currentWidget.DTENTPED.start;
            widget.currentRow.ENTREGAATE = currentWidget.DTENTPED.end;
            widget.currentRow.ENTREGATODOS = '';
        }else{
            widget.currentRow.ENTREGADE = '';
            widget.currentRow.ENTREGAATE = '';
            widget.currentRow.ENTREGATODOS = 'T';
        }
        
        widget.currentRow = this.sitConcat('PRIORIDADE','PRIORIDADE','PRIORIDADETODOS');

        // var array10 = currentWidget.PRIORIDADE;
        // var aux10 = '';
        // for(var s=0; s < array10.length; s++){
        //     aux10 = aux10 + array10[s] + '_';
        // }
        
        // widget.currentRow.PRIORIDADE = aux10;
        // widget.currentRow.PRIORIDADETODOS = '';
        
        widget.currentRow.NRORG = getLocalVar("NRORG").toString();
        
        this.criaRelatorio(widget);
    };
    
    this.visualizarRelatorio = function(){
        var widget = templateManager.container.getWidget('tabbedDadosPedido');
        if(widget.isValid()){
            if(widget.widgets[0].isValid()){
                this.setCurrentRow();    
            }
        }
    };
    
    this.criaRelatorio = function(widget) {
        Ped01100_dadosPedido_Service.geraRelatorio(widget.currentRow).then(function(birtURL) {
            // window.open(birtURL.messages[0].mess cage);
            var reportOpened = window.open(birtURL.messages[0].message);
			if(!reportOpened){
			    ScreenService.showMessage(ScreenService.i18n('Pop-up Blocker is enabled! Please add this site to your exception list.'));
			}
        }, function(error) {
            ScreenService.showMessage(error.data.error);
        });
       
       
       
       
        // var reportName = widget.container.getWidget('tabbedDadosPedido').currentRow.RELATORIO;
        // if (widget.isValid()) {
        //     General.openReportPopup(widget, this.abreRelatorio, [widget, widget.currentRow, reportName]);
        // }
    };
    
    this.abreRelatorio = function(widget, row, reportName) {
        General.openReport('/ped01100_relatorio', reportName, row);
    };
    
}

Configuration(function(ContextRegister){
    ContextRegister.register('Ped01100_dadosPedido', Ped01100_dadosPedido);
});
